<template>
  <div class="navbar__toggle" @click="toggleMenu">___</div>
  <div class="navigation" :class="menuActive ? 'open' : 'closed'">
    <div
      class="navbar d-flex align-items-start"
      :class="menuActive ? 'open' : 'closed'"
    >
      <div class="row">
        <a href="/">
          <img class="logo" alt="company logo" src="@/assets/logo.png" />
        </a>
        <div class="logout">
          <p>{{ user.name }}</p>
          <a class="logout-icon" href="/logout" title="Logout">
            <Icon class="ico" icon="material-symbols:logout" />
          </a>
        </div>
        <NavBarItem
          v-for="(navBarItem, index) in navBarItems"
          :key="'Item' + index"
          :item="navBarItem"
          :id="index"
        />
      </div>
    </div>
  </div>
</template>

<script>
import NavBarItem from "../molecules/NavBarItem.vue";
import { Icon } from "@iconify/vue";

export default {
  data() {
    return {
      navBarItems: [
        {
          name: "Dashboard",
          page: "home",
          icon: "DashboardIcon.png",
        },
        {
          name: "Routes",
          page: "routes",
          icon: "RoutesIcon.png",
          subItems: [{ name: "Toevoegen", link: "routes/add" }],
        },
        {
          name: "Accounts",
          page: "accounts",
          icon: "AccountsIcon.png",
          subItems: [{ name: "Toevoegen", link: "accounts/add" }],
        },
        {
          name: "Gebouwen",
          page: "buildings",
          icon: "BuildingsIcon.png",
          subItems: [
            { name: "Toevoegen", link: "buildings/add" },
            { name: "Planning", link: "buildings/shedule" },
          ],
        },
      ],
      menuActive: false,
    };
  },
  computed: {
    user() {
      return this.$store.state.auth.user;
    },
  },
  components: { NavBarItem, Icon },
  methods: {
    toggleMenu() {
      this.menuActive = !this.menuActive;
    },
  },
};
</script>

<style lang="scss">
.navbar {
  transition: all 400ms;
  background-color: var(--almost-black);
  max-width: 19rem;
  height: 100%;

  .logout {
    padding-top: 1rem;
    padding-bottom: 1rem;
    text-align: center;
    color: white;
    p {
      margin-bottom: 0.25rem;
    }
    border-top: 1px solid var(--yellow);
    border-bottom: 1px solid var(--yellow);
  }

  .logout-icon {
    padding-bottom: 1rem;
    color: white;
    width: 100%;
    height: 100%;
    justify-content: center;
    display: flex;
    .ico {
      width: 25px;
      height: 25px;
      display: block;
    }
  }

  img.logo {
    width: 80%;
    margin: 10%;
  }

  &__toggle {
    visibility: hidden;
    position: fixed;
    top: 0;
    left: 0;
    text-align: center;
    height: 40px;
    width: 40px;
    margin: 1rem;
    z-index: 1000;
    background: var(--yellow);
  }

  @media (max-width: 1240px) {
    z-index: 1000;
    &__toggle {
      visibility: visible;
    }
    &.open {
      transform: translateX(0);
    }
    &.closed {
      transform: translateX(-31rem);
    }
  }
}

.navigation {
  max-height: 100%;
  height: 100%;
  z-index: 100;
  @media (max-width: 1240px) {
    &.closed {
      z-index: 0;
      height: 100%;
      transform: translateX(-31rem);
    }
  }
}
</style>
